; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; CODE GNR AUTOMATIQUEMENT, NE PAS MODIFIER 
; MOINS D'AVOIR UNE RAISON TRS TRS VALABLE !!!
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Code gnr par : Dev-Module - V0.0.3
; Nom du projet : ToolBox Manager
; Nom du fichier : ToolBox Manager - ToolBox.pb
; Version du fichier : 0.0.0
; Programmation : OK
; Programm par : StarBootics
; Courriel : starbootics@cgocable.ca
; Date : 02-05-2015
; Mise  jour : 02-05-2015
; Cod pour : PureBasic 5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule ToolBox
  
  Declare SetCurrentFile(P_CurrentFile.s)
  Declare SetCurrentLine(P_CurrentLine.l)
  Declare SetCurrentRow(P_CurrentRow.l)
  Declare SetEditorOutputFile(P_EditorOutputFile.s)
  
  Declare Initialize(ProgramName.s)
  Declare Reset()
  Declare ReadPrefs(P_GroupName.s)
  Declare WritePrefs(P_GroupName.s)
  Declare ScanDirectories()
  Declare AddNewPath()
  Declare DeletePath(GadgetID)
  Declare Paths_To_GUI(GadgetID)
  Declare GUI_To_Paths(GadgetID)
  Declare Files_To_GUI(GadgetID)
  Declare GUI_To_Files(GadgetID)
  Declare Open_To_IDE(GadgetID)
  Declare Replace_ToolBoxFile_By_IncludeFile(ProgramName.s)
  Declare Load_ToolBoxFile_To_IDE(ProgramName.s)
  
EndDeclareModule

Module ToolBox
  
  #ToolBoxFile_Keyword_Length = 11
  #ToolBoxFile_Keyword_LCase = "toolboxfile"
  
  CompilerSelect #PB_Compiler_OS
      
    CompilerCase #PB_OS_Windows 
      #PathSep = "\"
      
    CompilerCase #PB_OS_Linux
      #PathSep = "/"
      
    CompilerCase #PB_OS_MacOS
      #PathSep = "/"
      
  CompilerEndSelect
  
  Structure ToolBoxEntry
    
    Name.s
    State.b
    
  EndStructure
  
  Structure Instance
    
    CurrentFile.s
    CurrentLine.l
    CurrentRow.l
    EditorOutputFile.s
    FileNameRegExp.i
    
    List Paths.ToolBoxEntry()
    Map Files.s()
    
  EndStructure
  
  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur fouille linaire <<<<<
  
  Procedure.l LinearSearchPathsByName(SearchValue.s, CaseSensitive.b = #False)
    
    Position.l = -1
    
    If CaseSensitive = #True
      
      ForEach Instance\Paths()
        
        If UCase(Instance\Paths()\Name) = UCase(SearchValue)
          Position = Index
          Break
        Else
          Index + 1
        EndIf
        
      Next
      
    Else
      
      ForEach Instance\Paths()
        
        If Instance\Paths()\Name = SearchValue
          Position = Index
          Break
        Else
          Index + 1
        EndIf
        
      Next
      
    EndIf
    
    ProcedureReturn Position
  EndProcedure
  
  Procedure.b VerifyEntryFile(P_EntryFileName.s)
    
    ForEach Instance\Files()
      
      If MapKey(Instance\Files()) = P_EntryFileName
        ToolBox_Entry_Name_Found.b = #True
        Break
      EndIf
      
    Next
    
    ProcedureReturn ToolBox_Entry_Name_Found
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< ExtractFileName <<<<<
  
  Procedure.s ExtractFileName(P_Line.s, P_Col.l)
    
    Char.s = Mid(P_Line, P_Col, 1)
    Column = P_Col
    
    While Char <> Chr(34)
      
      Char.s = Mid(P_Line, Column, 1)
      FirstPart.s = Char + FirstPart
      Column - 1  
      
    Wend
    
    Char.s = Mid(P_Line, Col, 1)
    Column = P_Col + 1
    
    While Char <> Chr(34)
      
      Char.s = Mid(P_Line, Column, 1)
      LastPart.s = LastPart + Char
      Column + 1  
      
    Wend
    
    File.s = FirstPart + LastPart
    
    If MatchRegularExpression(Instance\FileNameRegExp, File) = 0
      File = ""
    EndIf
    
    ProcedureReturn File
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetCurrentFile(P_CurrentFile.s)

    Instance\CurrentFile = P_CurrentFile

  EndProcedure

  Procedure SetCurrentLine(P_CurrentLine.l)

    Instance\CurrentLine = P_CurrentLine

  EndProcedure

  Procedure SetCurrentRow(P_CurrentRow.l)

    Instance\CurrentRow = P_CurrentRow

  EndProcedure

  Procedure SetEditorOutputFile(P_EditorOutputFile.s)

    Instance\EditorOutputFile = P_EditorOutputFile

  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Initialize <<<<<
  
  Procedure Initialize(ProgramName.s)
    
    Instance\FileNameRegExp = CreateRegularExpression(#PB_Any, "([a-z A-Z 0-9 -]*).(?i)(\bpb\b|\bpbi\b)")
    
    If IsRegularExpression(Instance\FileNameRegExp) = #Null
      MessageRequester(ProgramName + " - " + Language::Message("Error"), "ToolBox::Initialize() : " + Language::Message("Impossible to Create Regular Expression"))
      End
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<
  
  Procedure Reset()
    
    Instance\CurrentFile = ""
    Instance\CurrentLine = 0
    Instance\CurrentRow = 0
    Instance\EditorOutputFile = ""
    
    If IsRegularExpression(Instance\FileNameRegExp)
      FreeRegularExpression(Instance\FileNameRegExp)
      Instance\FileNameRegExp = 0
    EndIf
    
    ForEach Instance\Paths()
      Instance\Paths()\Name = ""
      Instance\Paths()\State = 0
    Next
    
    FreeList(Instance\Paths())
    
    ForEach Instance\Files()
      Instance\Files() = ""
    Next
    
    FreeMap(Instance\Files())
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture d'un groupe Prfrences <<<<<
  
  Procedure ReadPrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    Paths_Max = ReadPreferenceLong("Paths_Max", 0) - 1
    
    For PathsID = 0 To Paths_Max
      AddElement(Instance\Paths())
      Instance\Paths()\Name = ReadPreferenceString("Name_" + Str(PathsID), Instance\Paths()\Name)
      Instance\Paths()\State = ReadPreferenceLong("State_" + Str(PathsID), Instance\Paths()\State)
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture d'un groupe de Prfrences <<<<<
  
  Procedure WritePrefs(P_GroupName.s)
    
    PreferenceGroup(P_GroupName)
    
    WritePreferenceLong("Paths_Max", ListSize(Instance\Paths()))
    
    ForEach Instance\Paths()
      WritePreferenceString("Name_" + Str(ListIndex(Instance\Paths())), Instance\Paths()\Name)
      WritePreferenceLong("State_" + Str(ListIndex(Instance\Paths())), Instance\Paths()\State)
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Recursive_ScanToolBoxDirectories <<<<<
  
  Procedure Recursive_ScanToolBoxDirectories(Path.s)
    
    ToolBox_Path = ExamineDirectory(#PB_Any, Path, "")
    
    If ToolBox_Path <> #Null
      
      While NextDirectoryEntry(ToolBox_Path) <> 0
        
        EntryName.s = DirectoryEntryName(ToolBox_Path)
        
        If Left(EntryName, 1) <> "."
          
          If DirectoryEntryType(ToolBox_Path) = #PB_DirectoryEntry_File
            
            FileName.s = Trim(GetFilePart(EntryName))

            If MatchRegularExpression(Instance\FileNameRegExp, FileName)
              Instance\Files(FileName) = Path
            EndIf
            
          Else
            
            Recursive_ScanToolBoxDirectories(Path + EntryName + #PathSep)
            
          EndIf
          
        EndIf
        
      Wend
      
      FinishDirectory(ToolBox_Path)
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur ScanToolBoxDirectories <<<<<
  
  Procedure ScanDirectories()
    
    SortStructuredList(Instance\Paths(), #PB_Sort_Ascending, OffsetOf(ToolBoxEntry\Name), #PB_String)
    
    ForEach Instance\Paths()
      If Instance\Paths()\Name <> "" And Instance\Paths()\State = #True
        Recursive_ScanToolBoxDirectories(Instance\Paths()\Name)
      EndIf
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur AddNewToolBoxPath <<<<<
  
  Procedure AddNewPath()
    
    SortStructuredList(Instance\Paths(), #PB_Sort_Ascending, OffsetOf(ToolBoxEntry\Name), #PB_String)
    
    NewPath.s = PathRequester(Language::Message("Select ToolBox Path"), GetHomeDirectory())
    
    If NewPath <> ""
      
      ; We perform a Linear search on the Paths entry list
      ; to see if the user are not trying to add the same
      ; path twice. If it's not found we add the NewPath
      ; to the list. Then we re-sort the list.
      
      If LinearSearchPathsByName(NewPath) = -1
        
        AddElement(Instance\Paths())
        
        Instance\Paths()\Name = NewPath
        Instance\Paths()\State = #True
        
        SortStructuredList(Instance\Paths(), #PB_Sort_Ascending, OffsetOf(ToolBoxEntry\Name), #PB_String)
        
      EndIf
      
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur DeleteToolBoxPath <<<<<
  
  Procedure DeletePath(GadgetID)
    
    ; We perform a Linear search on the Paths Entry list
    ; to select the element the user want to delete.
    
    If LinearSearchPathsByName(GetGadgetItemText(GadgetID, GetGadgetState(GadgetID))) <> -1
      DeleteElement(Instance\Paths())
      SortStructuredList(Instance\Paths(), #PB_Sort_Ascending, OffsetOf(ToolBoxEntry\Name), #PB_String)
    EndIf
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Paths_To_GUI <<<<<
  
  Procedure Paths_To_GUI(GadgetID)
    
    ClearGadgetItems(GadgetID)
    
    ForEach Instance\Paths()
      
      If Instance\Paths()\Name <> ""
        
        AddGadgetItem(GadgetID, PathID, Instance\Paths()\Name, 0, 0)
        
        If Instance\Paths()\State = #True
          SetGadgetItemState(GadgetID, PathID, #PB_Tree_Checked)
        EndIf
        
        PathID + 1
        
      EndIf
      
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur GUI_To_Paths <<<<<
  
  Procedure GUI_To_Paths(GadgetID)
    
    ForEach Instance\Paths()
      
      If Instance\Paths()\Name <> ""
        
        If GetGadgetItemState(GadgetID, PathID) & #PB_Tree_Checked
          Instance\Paths()\State = #True
        Else
          Instance\Paths()\State = #False
        EndIf
        
        PathID + 1
        
      EndIf
      
    Next
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Files_To_GUI <<<<<
  
  Procedure Files_To_GUI(GadgetID)
    
    NewList FileList.s()
    
    ForEach Instance\Files()
      AddElement(FileList())
      FileList() = MapKey(Instance\Files())
    Next
    
    SortList(FileList(), #PB_Sort_Ascending)
    
    ForEach FileList()
      AddGadgetItem(GadgetID, ListIndex(FileList()), FileList())
      FileList() = ""
    Next
    
    FreeList(FileList())
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur GUI_To_Files <<<<<
  
  Procedure GUI_To_Files(GadgetID)
    
    NewList Files.s()
    
    ItemsMax = CountGadgetItems(GadgetID)
    
    For ItemsID = 0 To ItemsMax
      
      If GetGadgetItemState(GadgetID, ItemsID) = 1
        AddElement(Files())
        Files() = GetGadgetItemText(GadgetID, ItemsID)
      EndIf
      
    Next
    
    ForEach Files()
      
      Buffer.s + Chr(34) + Files() + Chr(34)
      
      If ListIndex(Files()) < ListSize(Files()) - 1
        Buffer + ", "
      EndIf
      
      Files() = ""
      
    Next
    
    ClearList(Files())
    
    NewList Lines.s()
    
    PB_Current_Source_File = ReadFile(#PB_Any, Instance\CurrentFile)
    
    If PB_Current_Source_File <> 0
      
      StringFormat = ReadStringFormat(PB_Current_Source_File)
      
      While Eof(PB_Current_Source_File) = 0
        AddElement(Lines())
        Lines() = ReadString(PB_Current_Source_File, StringFormat)
      Wend
      
      CloseFile(PB_Current_Source_File)
      
    EndIf
    
    PB_Current_Source_File_Mod = CreateFile(#PB_Any, Instance\CurrentFile, StringFormat)
    
    If PB_Current_Source_File_Mod  <> 0
      
      ForEach Lines()
        
        If ListIndex(Lines()) <> (Instance\CurrentLine - 1)
          
          ; Were not on the current line so we re-write this line as is.
          WriteStringN(PB_Current_Source_File_Mod, Lines(), StringFormat)
          
        Else
          
          If LCase(Left(Lines(), #ToolBoxFile_Keyword_Length)) = #ToolBoxFile_Keyword_LCase
            
            ; In this case the user want to add more file on the ToolBoxFile previously added.
            WriteStringN(PB_Current_Source_File_Mod, Lines() + ", " + Buffer, StringFormat)
            
          ElseIf Instance\CurrentRow <= 1 And Lines() = ""
            
            ; In this case the line is empty
            WriteStringN(PB_Current_Source_File_Mod, "ToolBoxFile " + Buffer, StringFormat)
            
          Else
            
            ; In this case the line is not empty so we split this line in two parts using the 
            ; current row then we add our stuff right between them. Tought luck if the user
            ; has make a mistake. He will have to correct the error manually, no "UNDO" 
            ; possible.
            
            FrontPart.s = Left(Lines(), Instance\CurrentRow)
            BackPart.s = Right(Lines(), Len(Lines()) - Instance\CurrentRow)
            WriteStringN(PB_Current_Source_File_Mod, FrontPart + "ToolBoxFile " + Buffer + BackPart)
            
          EndIf
          
        EndIf
        
        Lines() = ""
        
      Next
      
      CloseFile(PB_Current_Source_File_Mod)
      
    EndIf
    
    ClearList(Lines())
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Open_ToolBoxFile_To_IDE <<<<<
  
  Procedure Open_To_IDE(GadgetID)
    
    ItemsMax = CountGadgetItems(GadgetID)
    
    For ItemsID = 0 To ItemsMax
      
      If GetGadgetItemState(GadgetID, ItemsID) = #True
        
        Entry.s = GetGadgetItemText(GadgetID, ItemsID)
        
        If Entry <> ""
          
          If FindMapElement(Instance\Files(), Entry)
            
            Buffer.s + Chr(34) + Instance\Files() + MapKey(Instance\Files()) + Chr(34)
            
            If FieldID < ItemsMax
              Buffer + " "
            EndIf
            
          EndIf
          
        EndIf
        
      EndIf
      
    Next
    
    If Buffer <> ""
      IDE.s = GetEnvironmentVariable("PB_TOOL_IDE")
      RunProgram(IDE, Buffer, GetPathPart(IDE))
    EndIf
    
  EndProcedure 
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Replace_ToolBoxFile_By_IncludeFile <<<<<
  
  Procedure Replace_ToolBoxFile_By_IncludeFile(ProgramName.s)
    
    NewList Lines.s()
    
    PB_Output_Source_File = ReadFile(#PB_Any, Instance\EditorOutputFile)
    
    If PB_Output_Source_File <> 0
      
      StringFormat = ReadStringFormat(PB_Output_Source_File)
      
      While Eof(PB_Output_Source_File) = 0
        AddElement(Lines())
        Lines() = ReadString(PB_Output_Source_File, StringFormat)
      Wend
      
      CloseFile(PB_Output_Source_File)
      
    EndIf
    
    PB_Output_Source_File_Mod = CreateFile(#PB_Any, Instance\EditorOutputFile)
    
    If PB_Output_Source_File_Mod  <> 0
      
      ForEach Lines()
        
        If LCase(Left(Trim(Lines()), #ToolBoxFile_Keyword_Length)) = #ToolBoxFile_Keyword_LCase
          
          ToolBoxFiles.s = StringField(lines(), 2, "ToolBoxFile")
          StartPosition = FindString(lines(), "ToolBoxFile")
          
          If StartPosition > 1
            Tab.s = Left(lines(), StartPosition - 1)
          EndIf
          
          FieldMax = CountString(ToolBoxFiles, ",") + 1
          
          For FieldID = 1 To FieldMax
            
            Entry.s = RemoveString(Trim(StringField(ToolBoxFiles, FieldID, ",")), Chr(34))

            If Entry <> ""
              
              If FindMapElement(Instance\Files(), Entry) <> #Null
                
                WriteStringN(PB_Output_Source_File_Mod, Tab + "IncludeFile " + Chr(34) + Instance\Files() + MapKey(Instance\Files()) + Chr(34), StringFormat)
                
              Else
                
                ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                ; File not found error management
                
                ; If the Entry is not found in the ToolBox Entry so we just replace the "ToolBoxFile" 
                ; keyword by "IncludeFile" keyword. Then the compiler will tell the programmer about 
                ; a non existing source file.
                ;
                ; Maybe it's possible to Popup an error message but I don't know if it's possible to
                ; stop the compiling process. Without stopping it, both program (Compiler and ToolBox) 
                ; will tell the user about the same missing file problem.
                
                MessageRequester(ProgramName + " - " + Language::Message("Error"), ReplaceString(Language::Message("The file %FILENAME% is not present in the ToolBox."), "%FILENAME%", Entry))
                WriteStringN(PB_Output_Source_File_Mod, Tab + "IncludeFile " + Chr(34) + Entry + Chr(34), StringFormat)
                
              EndIf
              
            EndIf
            
          Next
          
        Else
          
          WriteStringN(PB_Output_Source_File_Mod, Lines(), StringFormat)
          
        EndIf
        
        lines() = ""
        
      Next
      
      CloseFile(PB_Output_Source_File_Mod)
      
    EndIf
    
    ClearList(Lines())
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Load_ToolBoxFile_To_IDE <<<<<
  
  Procedure Load_ToolBoxFile_To_IDE(ProgramName.s)

    PB_Current_Source_File = ReadFile(#PB_Any, Instance\CurrentFile)

    If PB_Current_Source_File <> 0
      
      StringFormat = ReadStringFormat(PB_Current_Source_File)
      
      For LineID = 1 To Instance\CurrentLine - 1
        Line.s = ReadString(PB_Current_Source_File, StringFormat)
      Next
      
      ToolBoxFile_To_Load.s = ReadString(PB_Current_Source_File, StringFormat)
      CloseFile(PB_Current_Source_File)
      
    EndIf
    
    If Instance\CurrentRow > #ToolBoxFile_Keyword_Length
      
      Entry.s = RemoveString(ExtractFileName(ToolBoxFile_To_Load, Instance\CurrentRow), Chr(34))

      If VerifyEntryFile(Entry)
        Instance\Files(Entry)
        Buffer.s + Chr(34) + Instance\Files() + MapKey(Instance\Files()) + Chr(34)
      EndIf

    Else
      
      ToolBoxFiles.s = RemoveString(Trim(Right(ToolBoxFile_To_Load, Len(ToolBoxFile_To_Load) - #ToolBoxFile_Keyword_Length)), Chr(34))

      FieldMax = CountString(ToolBoxFiles, ",") + 1
      
      For FieldID = 1 To FieldMax
        
        Entry.s = Trim(StringField(ToolBoxFiles, FieldID, ","))
        
        If Entry <> ""
          
          If FindMapElement(Instance\Files(), Entry) <> #Null
           
            Buffer.s + Chr(34) + Instance\Files() + MapKey(Instance\Files()) + Chr(34)
            
            If FieldID < FieldMax
              Buffer + " "
            EndIf
            
          Else
            
            ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            ; File not found error management
            
            ; If the Entry is not found in the ToolBox Entry we just don't add it to the current 
            ; insert. We need to add an error message about a non-exisiting file. This can happen 
            ; when a user write ToolBoxFile "...", "..." manually. 
            
            MessageRequester(ProgramName + " - " + Language::Message("Error"), ReplaceString(Language::Message("The file %FILENAME% is not present in the ToolBox."), "%FILENAME%", Entry))

          EndIf
          
        EndIf
        
      Next
      
    EndIf
    
    If Buffer <> ""
      IDE.s = GetEnvironmentVariable("PB_TOOL_IDE")
      RunProgram(IDE, Buffer, GetPathPart(IDE))
    EndIf
    
  EndProcedure 
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (129000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = -----
; EnableUnicode
; EnableXP
; CompileSourceDirectory